require "globalconfig"

local cclog = function(...)
    print(string.format(...))
end
ed.cclog = cclog

function __G__TRACKBACK__(msg)
    print("----------------------------------------")
    print("LUA ERROR: " .. tostring(msg) .. "\n")
    print(debug.traceback())
    print("----------------------------------------")
end
ed.__G__TRACKBACK__ = __G__TRACKBACK__

local checkDailyBonus = function()
    local today = ed.settings.getTodayDate()
    local savedDate = ed.settings.getSavedDate()

    if today ~= savedDate then
        ed.settings.setSavedDate(today)

        local coins = ed.settings.getGameCoins()
        coins = coins + kDailyBonus
        ed.settings.setGameCoins(coins)

        local title = Settings_getUTF8LocaleString("msgBonusTitle")
        local message = Settings_getUTF8LocaleString("msgBonusBody")
        CCMessageBox(string.format(message, kDailyBonus), title)
    end
end
ed.checkDailyBonus = checkDailyBonus


local function main()
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)

    local anySDKWrapper = AnySDKWrapper:getInstance()
    anySDKWrapper:initSDK("786ED927-EAB2-959C-9B5E-0863609D5F91", "e8f33fa53c7d13a577e63d1841d233fb", "03B288043E4B53E22C87ACAE9B547508")

    math.randomseed(os.time())
    local langType = CCApplication:sharedApplication():getCurrentLanguage()
    ed.settings.loadLanguageDefault(langType == kLanguageChinese)

    if ed.settings.isFirstPlayGame() then
        ed.settings.setGameCoins(kOrgGameCoins)
        ed.settings.setFirstPlayGame()
    end

    ed.loadConstants()

    ed.checkDailyBonus()

    ed.pushScene(ed.ui.game.create())

    local update_entry_id = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(ed.gameUpdate, 0, false)


end

xpcall(function ()
    local ed = ed
    ed.loadAllModules()

    main()
end,
__G__TRACKBACK__)

